unit SpriteCode;

interface
uses sprites,mainUnit,windows;

const
  BulletLife : integer = 250;

type
  TBullet = class(TFractSprite)
    life : integer;

    constructor Create(aImage : integer);
    procedure   HitEdge(e : TEdges); override;
    procedure   Tick; override;
  end;

  TGoodBullet = class(TBullet)
    constructor Create;
  end;

  TGalax = class(TAnimSprite)
    tix : integer;

    constructor Create; virtual;
    procedure Tick; override;
  end;

  TScrager = class(TGalax)
    constructor Create; override;
    procedure Tick; override;
  end;

implementation

constructor TBullet.Create(aImage : integer);
begin
  inherited Create(Form1.SpriteEngine1);

  life:=bulletLife;
  image:=aImage;
  Show;
end;

procedure TBullet.HitEdge(e : TEdges);
begin
  kill;
end;

procedure TBullet.Tick;
begin
  inherited Tick;

  dec(life);

  if life<=0 then
    Kill;
end;

constructor TGoodBullet.Create;
begin
  inherited Create(42);
  rx:=Ship.rx+6;
  ry:=Ship.ry+6;

  rvx:=Ship.Rvx*2;
  rvy:=Ship.Rvy*2;
end;

constructor TGalax.Create;
begin
  inherited Create(Form1.SpriteEngine1,2,8);

  flags:=flags or wantBounce;
  tix:=0;
  speed:=8;

  y:=Form1.DGCScreen1.back.height div 2;

  if random(100)>50 then
    x:=Form1.DGCScreen1.back.width-24
  else
    x:=24;

  Show;
end;

procedure TGalax.Tick;
begin
  inherited tick;

  dec(tix);
  if tix<0 then
    begin
      tix:=random(100)+10;
      vx:=random(4)-2;
      vy:=random(4)-2;
    end;
end;

constructor TScrager.Create;
begin
  inherited Create;

  imageBase:=10;
  image:=10;
end;

procedure TScrager.Tick;
var
  i : integer;

begin
  inherited tick;

  i:=random(100);
  if (i>90) and (i<95) then
    with TBullet.Create(43) do
      begin
        rx:=self.x+6;
        ry:=self.y+6;
        image:=43;
        rvx:=random(8)-4;
        rvy:=random(8)-4;

        Show;
      end;
end;

end.
